#include <stdio.h>
#include <math.h>
char h[72][80],c1[14],c2[14];
double a8[8],b8[8],x1,x2,x3,x4,pi,cx,cy;
main(int ac,char **av)
{
  int i,j,k,n1,n2; FILE *fp;
  if(ac<2){printf("\n\t*** add real_center_message on fits_head with A8 ***\n");
            printf("\n\tUsage: add_real_coord p*.fit\n\n"); exit(0); }
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  for(i=1;i<ac;i++){
    fp=fopen(av[i],"rb+"); if(!fp)continue;
    fread(h,72,80,fp); 
    if(h[5][62]==32){       // no real center messages
      k=indexpos(h,"NAXIS1  ",72);
      sscanf(&h[k][20],"%d",&n1); sscanf(&h[k+1][20],"%d",&n2);
      k=indexpos(h,"A81     ",72); if(k==72)goto l10;
      for(j=0;j<8;j++)sscanf(&h[k+j][10],"%lf",&a8[j]);
      xytoad(a8,b8); x1=(n1+1.)/2.; x2=(n2+1.)/2.;
      xy_rad(a8[6],a8[7],x1,x2,&x3,&x4,2,0); 
      toms2(x3,c1,1); toms2(x4,c2,0); 
      sprintf(&h[5][62],"CCD real_center:"); h[5][78]=32;
      sprintf(&h[6][52],"%s %s",c1,c2);      h[6][78]=32;
      fseek(fp,0,0); fwrite(h,72,80,fp);
      printf("%d: %s  real_center:%s %s\n",i,av[i],c1,c2);
    } 
l10:  fclose(fp);
  } printf("0k !\n");
}

toms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
/*
 *  hour or degree to char_line
 *   if k=1 (hour case) in **:**:**.***
 *       k=0 (degree       -**:**:**.**
 *       */
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%6.3f",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

#define bok  48.
xy_rad(ac,dc,x,y,ra,de,type,k)
double ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);
    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
//                                 printf("%lf\n",tmp);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}
